'Title: Metallic Ribbons
'File: RIBBON.BAS
'Date: April 1997
'Author: Wayne Wallace
'E-mail: wwallace@iquest.net

'************************Please Note********************************
'The program line "speed = 1000" controls the speed of the program.
'Adjust this value to match the program to the speed of your computer.
'To stop the program while it is running, press any key.
'********************************************************************

'How it Works:

'Using the SINE and COSINE funtions, an oval was drawn.  As the oval is
'being drawn the X and Y coordinates are being incremented, thus the oval
'never finishes but instead creates unfinished loops across the screen
'producing a ribbon effect.  The oval is made up of four seperate lines.
'To enhance the ribbon, each line is colored in different shades.
'This produces a metallic effect.

SCREEN 13         'dimensions 350 by 200 by 256 colors
DEFINT A-M        'define variables a to m as integer (whole numbers)
speed = 1000      'controls speed of ribbon (higher number/slower speed)
'----------
GOSUB newcolors   'load Screen 13's color palette

WINDOW (-12, -10)-(14, 10)            'redimension screen size
'----------------------------------
k1 = 1: k2 = 64: k3 = 127: k4 = 190   'initial palette slots
a1 = 1: a2 = 1: a3 = 1: a4 = 1        'variable to step thru colors
p = 1: q = 1: v1 = .007: v2 = .007    'bounce variables
'---------------------------------
FOR loops = 1 TO 10500
IF loops MOD 3500 = 0 THEN GOSUB newcolors  'new colors every 3500 loops
IF INKEY$ <> "" THEN END
'---------------------------
rr = rr + .01                 'animate ribbon in steps of .01
x = (4 * COS(rr)) + p         'determines loop size of ribbon
y = 8 * SIN(rr) + q           'determines loop size of ribbon
'---------------------        'draw four lines for ribbon length--
LINE (x, y)-(x + 1, y), k1
LINE -(x + 2, y), k2
LINE -(x + 3, y), k3
LINE -(x + 4, y), k4
'-------------------
p = p + v2                  'step and bounce ribbon across the screen
q = q + v1
'------------------------
IF x > 10 THEN v2 = -.007
IF x < -17 THEN v2 = .007
IF y > 11 THEN v1 = -.007
IF y < -14 THEN v1 = .007
'----------------------
IF k1 > 61 THEN a1 = -1
IF k1 < 2 THEN a1 = 1
k1 = k1 + a1
'----------------------
IF k2 > 124 THEN a2 = -1
IF k2 < 65 THEN a2 = 1
k2 = k2 + a2
'-----------------------
IF k3 > 187 THEN a3 = -1
IF k3 < 128 THEN a3 = 1
k3 = k3 + a3
'-----------------------
IF k4 > 250 THEN a4 = -1
IF k4 < 191 THEN a4 = 1
k4 = k4 + a4
'-----------------------
FOR delay = 1 TO speed
NEXT delay
NEXT loops
SLEEP 3
GOSUB newcolors
CLS
PALETTE
LOCATE 12, 17: PRINT "The End"
END


newcolors:
FOR m = 1 TO 4
READ lo, hi, rd%, gr, bl, r%, g, b
GOSUB spectrum
NEXT m
RETURN

spectrum:
FOR hues = lo TO hi
   IF INKEY$ <> "" THEN END
   h& = rd% + (256 * gr) + (65536 * bl)
   PALETTE hues, h&
   rd% = rd% + r%
   gr = gr + g
   bl = bl + b
NEXT hues
RETURN

'starting colors:
'red/green
DATA 1, 62, 62, 0, 0, -1, 1, 0
'black/silver
DATA 63, 125, 0, 0, 0, 1, 1, 1
'yellow/blue
DATA 126, 188, 62, 62, 0, -1, -1, 1
'black/silver
DATA 189, 251, 0, 0, 0, 1, 1, 1

'2nd color set
'black/magenta
DATA 1, 62, 0, 0, 0, 1, 0, 1
'black/silver
DATA 63, 125, 0, 0, 0, 1, 1, 1
'black/magenta
DATA 126, 188, 0, 0, 0, 1, 0, 1
'black/silver
DATA 189, 251, 0, 0, 0, 1, 1, 1

'3rd color set
'black/blue
DATA 1, 62, 0, 0, 0, 0, 0, 1
'black/yellow
DATA 63, 125, 0, 0, 0, 1, 1, 0
'black/blue
DATA 126, 188, 0, 0, 0, 0, 0, 1
'black/yellow
DATA 189, 251, 0, 0, 0, 1, 1, 0

'4th color set
'black/silver
DATA 1, 62, 0, 0, 0, 1, 0, 0
'black/red
DATA 63, 125, 0, 0, 0, 1, 1, 1
'black/silver
DATA 126, 188, 0, 0, 0, 0, 0, 1
'black/blue
DATA 189, 251, 0, 0, 0, 1, 1, 1

'clear palette
'black to black
DATA 1, 62, 0, 0, 0, 0, 0, 0
'black to black
DATA 63, 125, 0, 0, 0, 0, 0, 0
'black to black
DATA 126, 188, 0, 0, 0, 0, 0, 0
'black to black
DATA 189, 251, 0, 0, 0, 0, 0, 0

